
#include "kolibri.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"

extern char CAR_01[1326];
extern char CAR_02[1326];
extern char DONKEY_01[867];
extern char DONKEY_02[663];

int start;
int dox, doy;
int drx, dry;

int drn, don;

void game_start()
{
drx = -1;
dry = 0;
doy = rand()%40+130;

dox = rand()%2;
if (0 == dox)
	dox--;

drn = don = 0;
}


void screen_back()
{

int y;
char num[2];
num[1]=0;

kol_paint_bar(0, 0, 320, 200, 0x888888);

kol_paint_bar(6, 6, 97-6, 195-6, 0x00a8a8);
kol_paint_bar(183, 6, 305-183, 195-6, 0x00a8a8);

kol_paint_string(30, 30, "Donkey", 0x80eeeeee);
kol_paint_string(200, 30, "Driver", 0x80eeeeee);

num[0] = don+'0';
kol_paint_string(30, 40, num, 0x80eeeeee);

num[0] = drn/10+'0';
kol_paint_string(200, 40, num, 0x80eeeeee);


kol_paint_string(200, 120, "Press Space", 0x80eeeeee);
kol_paint_string(200, 130, "Bar to switch", 0x80eeeeee);
kol_paint_string(200, 140, "lanes", 0x80eeeeee);
kol_paint_string(200, 160, "Press ESC", 0x80eeeeee);
kol_paint_string(200, 170, "to exit", 0x80eeeeee);


for (y=10; y<180; y+=20)
	kol_paint_line(140, y-10*(doy%2), 140, y+10-10*(doy%2), 0xffffff);

kol_paint_line(100, 0, 100, 199, 0xffffff);
kol_paint_line(180, 0, 180, 199, 0xffffff);

}

void screen_draw()
{

int y;

doy-=5;
if (doy < -50)
	{

	dox = rand()%2;
	if (0 == dox)
		dox--;

	doy = rand()%40+130;
	dry += 10;
	drn++;
	if (0 == drn%10)
		dry = 0;
	}

kol_screen_wait_rr();

if (start)
	{
	kol_paint_bar(0, 0, 320, 200, 0x888888);
	kol_paint_string(30, 30, "D O N K E Y", 0x8000ee00);
	kol_paint_string(30, 40, "version 0.1", 0x8000ee00);
	kol_paint_string(30, 50, "ported to KolibriOS by O.Bogomaz", 0x8000ee00);
	kol_paint_string(30, 150, "Press space bar to continue", 0x80eeee00);
	kol_paint_end();
	return;
	}

screen_back();

if ((drx == dox)&&(dry > doy-14)&&(dry < doy+14))
	{
	kol_paint_string(30, 120, "BOOM!", 0x80eeeeee);
	don++;
	dry = 0;
	for (y = dry; y<2;y++)
		{
		kol_sleep(8);
		kol_screen_wait_rr();
		screen_back();
		kol_paint_image(140-13-(y+1)*20, 120-dry+(y+1)*20, 13, 34, CAR_01);
		kol_paint_image(120+(y+3)*20, 120-dry+(y+1)*20, 13, 34, CAR_02);
		kol_paint_image(140-17-(y+1)*20, 120-(y+1)*20, 17, 17, DONKEY_01);
		kol_paint_image(140+(y+3)*20, 120-(y+1)*20, 13, 17, DONKEY_02);
		}

	dox = rand()%2;
	if (0 == dox)
		dox--;

	doy = rand()%40+130;
	}

kol_paint_image(140-13-drx*20, 120-dry, 13, 34, CAR_01);
kol_paint_image(140-drx*20, 120-dry, 13, 34, CAR_02);

kol_paint_image(140-17-dox*20, 120-doy, 17, 17, DONKEY_01);
kol_paint_image(140-dox*20, 120-doy, 13, 17, DONKEY_02);

}

void wnd_draw()
{
kol_paint_start();
kol_wnd_define(50, 50, 320, 200, 0x888888);
kol_wnd_caption("Donkey v0.1");
screen_draw();
kol_paint_end();
}




void kol_main()
{

unsigned event;
unsigned key;

srand(kol_mouse_pos());
start = 1;

wnd_draw();

for (;;)
	{

	kol_sleep(5);
	screen_draw();
	event = kol_event_check();

	switch (event)
		{
		case 1:
			wnd_draw();
			break;

		case 2:
			key = (kol_key_get() & 0xff00)>>8;
			if (start && (32==key))
				{
				start = 0;
				game_start();
				screen_draw();
				break;
				}
			if (27 == key)
				{
				start = 1;
				break;
				}
			if (32 == key)
				{
				drx *= -1;
				screen_draw();
				}
			break;

		case 3:
			if ( 1 == (kol_btn_get() & 0xff00)>>8 )
				kol_exit();
			break;

		};
	}

}
