#include <stdio.h>
#include <iostream.h>
#include <process.h>

const char hextable[] = "0123456789abcdef";

void gotohell(char *why){
     cout << "\nFatal Error: " << why << "\n";
     exit(1);
}

void putstring(char *string,FILE *file){
 unsigned int z=0;
 unsigned char y;
 y=string[z++];
 while(y){
  putc(y,file);
  y=string[z++];
 }
}

void puthex(unsigned char num, FILE *file){
  putc((int)hextable[(num >> 4)], file);
  putc((int)hextable[(num & 0x0f)], file);
  putc('h', file);
}

void main(void){
	char filename[256];
     unsigned long length;
     unsigned long x;
	FILE *i_filehandle, *o_filehandle;
     unsigned char y;
     unsigned char count=0;
     unsigned char z=0;
     unsigned char firsttime=1;

	//clearscreen & bold

	cout << "Ed Pizzi's binary file to DB array converter.\nCopyright 1999, Ed Pizzi\n\nEnter input filename: ";
	cin >> filename;
	if (!(i_filehandle = fopen(filename, "rb"))){
		gotohell("Could not find source file.");
	}
     do{
     y=filename[z++];
     } while (y!='.' && y);
     z--;
     filename[z++]='.';
     filename[z++]='i';
     filename[z++]='n';
     filename[z++]='c';
     filename[z++]=0;
     cout << "Creating " << filename << " ...\n";
	if(!(o_filehandle = fopen(filename, "wb"))){
		gotohell("Could not create output file");
	}
     fseek(i_filehandle,0,SEEK_END);
	length = ftell(i_filehandle);
     rewind(i_filehandle);

     for (x = 0; x < length; x++){
        count &= 0x07;
        if (!(count)){
            if(!firsttime){
            putc(0x0d,o_filehandle);
            putc(0x0a,o_filehandle);
            } else firsttime=0;
            putstring("        db 0",o_filehandle);
            count = 0;
        }
        else {
            putstring(",0",o_filehandle);
        }
        puthex(getc(i_filehandle), o_filehandle);
        count++;
	}
     if (!firsttime) {
      putc(0x0d,o_filehandle);
      putc(0x0a,o_filehandle);
      putstring("        ;   Converted with Ed Pizzi's DB Converter",o_filehandle);
      putc(0x0d,o_filehandle);
      putc(0x0a,o_filehandle);
     }
	fclose(i_filehandle);
	fclose(o_filehandle);
     cout << "Have a nice day.\n";
}